tigase.server.ext

## Class ComponentProtocol

- java.lang.Object
- - tigase.server.BasicComponent
  - - tigase.server.AbstractMessageReceiver
    - - tigase.server.ConnectionManager<ComponentIOService>
      - - tigase.server.ext.ComponentProtocol

- All Implemented Interfaces:
    Configurable, XMPPService, IOServiceListener<ComponentIOService>, ComponentProtocolHandler, MessageReceiver, ServerComponent, StatisticsContainer, VHostListener, XMPPIOServiceListener<ComponentIOService>

      public class ComponentProtocol
      extends ConnectionManager<ComponentIOService>
      implements ComponentProtocolHandler

  Created: Sep 30, 2009 8:28:13 PM
  Version:
    $Rev$
  Author:
    Artur Hefczyc

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class tigase.server.ConnectionManager

      `ConnectionManager.LIMIT_ACTION, ConnectionManager.WATCHDOG_PING_TYPE`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `AUTHENTICATION_TIMEOUT_PROP_KEY` Field description
    `static String` | `CLOSE_ON_SEQUENCE_ERROR_PROP_KEY` Field description
    `static String` | `EXTCOMP_BIND_HOSTNAMES` Field description
    `static String` | `EXTCOMP_REPO_CLASS_PROP_KEY` Field description
    `static String` | `EXTCOMP_REPO_CLASS_PROP_VAL` Field description
    `static String` | `EXTCOMP_REPO_CLASS_PROPERTY` Field description
    `static String` | `IDENTITY_TYPE_KEY` Field description
    `static String` | `IDENTITY_TYPE_VAL` Field description
    `static String` | `MAX_AUTH_ATTEMPTS_PROP_KEY` Field description
    `static String` | `PACK_ROUTED_KEY` Field description
    `boolean` | `PACK_ROUTED_VAL` Field description
    `static String` | `RETURN_SERVICE_DISCO_KEY` Field description
    `static boolean` | `RETURN_SERVICE_DISCO_VAL` Field description

    - ### Fields inherited from class tigase.server.ConnectionManager

      `connectionDelay, elements_number_limit, ELEMENTS_NUMBER_LIMIT_PROP_KEY, ELEMENTS_NUMBER_LIMIT_PROP_VAL, HT_TRAFFIC_THROTTLING_PROP_KEY, HT_TRAFFIC_THROTTLING_PROP_VAL, LAST_MINUTE_BIN_LIMIT_PROP_VAL, LAST_MINUTE_PACKETS_LIMIT_PROP_VAL, MAX_INACTIVITY_TIME, MAX_RECONNECTS_PROP_KEY, net_buffer, NET_BUFFER_HT_PROP_KEY, NET_BUFFER_HT_PROP_VAL, NET_BUFFER_LIMIT_HT_PROP_VAL, NET_BUFFER_LIMIT_PROP_KEY, NET_BUFFER_LIMIT_ST_PROP_VAL, NET_BUFFER_PROP_KEY, NET_BUFFER_ST_PROP_KEY, NET_BUFFER_ST_PROP_VAL, pingElement, PORT_CLASS_PROP_KEY, PORT_IFC_PROP_KEY, PORT_IFC_PROP_VAL, PORT_KEY, PORT_LOCAL_HOST_PROP_KEY, PORT_REMOTE_HOST_PROP_KEY, PORT_REMOTE_HOST_PROP_VAL, PORT_SOCKET_PROP_KEY, PORT_TYPE_PROP_KEY, PORTS_PROP_KEY, PROP_KEY, ST_TRAFFIC_THROTTLING_PROP_KEY, ST_TRAFFIC_THROTTLING_PROP_VAL, TLS_PROP_KEY, TLS_REQUIRED_PROP_KEY, TLS_REQUIRED_PROP_VAL, TLS_USE_PROP_KEY, TLS_USE_PROP_VAL, TOTAL_BIN_LIMIT_PROP_VAL, TOTAL_PACKETS_LIMIT_PROP_VAL, TRAFFIC_THROTTLING_PROP_KEY, WATCHDOG_DELAY, WATCHDOG_PING_TYPE_KEY, WATCHDOG_TIMEOUT, watchdogDelay, watchdogPingType, watchdogTimeout, WHITE_CHAR_ACK_PROP_KEY, WHITE_CHAR_ACK_PROP_VAL, XMPP_ACK_PROP_KEY, XMPP_ACK_PROP_VAL`

    - ### Fields inherited from class tigase.server.AbstractMessageReceiver

      `HOUR, INCOMING_FILTERS_PROP_KEY, INCOMING_FILTERS_PROP_VAL, MAX_QUEUE_SIZE_PROP_KEY, MAX_QUEUE_SIZE_PROP_VAL, maxInQueueSize, maxOutQueueSize, maxQueueSize, MINUTE, OUTGOING_FILTERS_PROP_KEY, OUTGOING_FILTERS_PROP_VAL, SCHEDULER_THREADS_PROP_KEY, SECOND`

    - ### Fields inherited from class tigase.server.BasicComponent

      `admins, ALL_PROP_KEY, COMMAND_PROP_NODE, scriptCommands, SCRIPTS_DIR_PROP_DEF, SCRIPTS_DIR_PROP_KEY, vHostManager`

    - ### Fields inherited from interface tigase.server.ext.ComponentProtocolHandler

      `EXTCOMP_BIND_HOSTNAMES_PROP_KEY, REPO_ITEM_KEY`

    - ### Fields inherited from interface tigase.conf.Configurable

      `ADMINS_PROP_KEY, AMP_CLASS_NAME, AMP_CLUST_CLASS_NAME, AUTH_DOMAIN_POOL_CLASS, AUTH_REPO_DOMAINS_PROP_KEY, AUTH_REPO_PARAMS_NODE, AUTH_REPO_POOL_CLASS, AUTH_REPO_URL_PROP_KEY, BOSH_CLUST_COMP_CLASS_NAME, BOSH_COMP_CLASS_NAME, C2S_CLUST_COMP_CLASS_NAME, C2S_COMP_CLASS_NAME, CL_COMP_CLASS_NAME, CLUSTER_CONECT, CLUSTER_CONTR_CLASS_NAME, CLUSTER_LISTEN, CLUSTER_MODE, CLUSTER_NODES, CLUSTER_NODES_PROP_KEY, COMP_PROT_CLASS_NAME, COMPONENT_ID_PROP_KEY, DEF_AMP_NAME, DEF_BOSH_NAME, DEF_C2S_NAME, DEF_CL_COMP_NAME, DEF_CLUST_CONTR_NAME, DEF_COMP_PROT_NAME, DEF_EXT_COMP_NAME, DEF_HOSTNAME_PROP_KEY, DEF_MONITOR_NAME, DEF_S2S_NAME, DEF_SM_NAME, DEF_SRECV_NAME, DEF_SSEND_NAME, DEF_STATS_NAME, DEF_VHOST_MAN_NAME, DEF_WS2S_NAME, DERBY_REPO_CLASS_PROP_VAL, DERBY_REPO_URL_PROP_VAL, DRUPAL_REPO_URL_PROP_VAL, DRUPALWP_REPO_CLASS_PROP_VAL, DUMMY_REPO_CLASS_PROP_VAL, EXT_COMP_CLASS_NAME, GEN_ADMINS, GEN_AUTH_DB, GEN_AUTH_DB_URI, GEN_COMP_CLASS, GEN_COMP_NAME, GEN_CONF, GEN_CONFIG, GEN_CONFIG_ALL, GEN_CONFIG_COMP, GEN_CONFIG_CS, GEN_CONFIG_DEF, GEN_CONFIG_SM, GEN_DEBUG, GEN_DEBUG_PACKAGES, GEN_EXT_COMP, GEN_MAX_QUEUE_SIZE, GEN_SCRIPT_DIR, GEN_SM_PLUGINS, GEN_SREC_ADMINS, GEN_SREC_DB, GEN_SREC_DB_URI, GEN_TEST, GEN_TRUSTED, GEN_USER_DB, GEN_USER_DB_URI, GEN_USER_DB_URI_PROP_KEY, GEN_VIRT_HOSTS, HOSTNAMES_PROP_KEY, LIBRESOURCE_REPO_CLASS_PROP_VAL, LIBRESOURCE_REPO_URL_PROP_VAL, MONITOR_CLASS_NAME, MONITOR_CLUST_CLASS_NAME, MONITORING, MYSQL_REPO_CLASS_PROP_VAL, MYSQL_REPO_URL_PROP_VAL, PGSQL_REPO_CLASS_PROP_VAL, PGSQL_REPO_URL_PROP_VAL, ROUTER_COMP_CLASS_NAME, S2S_CLUST_COMP_CLASS_NAME, S2S_COMP_CLASS_NAME, SHARED_AUTH_REPO_PARAMS_PROP_KEY, SHARED_AUTH_REPO_PROP_KEY, SHARED_USER_REPO_PARAMS_PROP_KEY, SHARED_USER_REPO_PROP_KEY, SM_CLUST_COMP_CLASS_NAME, SM_COMP_CLASS_NAME, SRECV_COMP_CLASS_NAME, SSEND_COMP_CLASS_NAME, STANZA_WHITE_CHAR_ACK, STANZA_XMPP_ACK, STATS_CLASS_NAME, STRINGPREP_PROCESSOR, TIGASE_AUTH_REPO_CLASS_PROP_VAL, TIGASE_AUTH_REPO_URL_PROP_VAL, TIGASE_CUSTOM_AUTH_REPO_CLASS_PROP_VAL, TRUSTED_PROP_KEY, USER_DOMAIN_POOL_CLASS, USER_REPO_DOMAINS_PROP_KEY, USER_REPO_PARAMS_NODE, USER_REPO_POOL_CLASS, USER_REPO_POOL_SIZE, USER_REPO_POOL_SIZE_PROP_KEY, USER_REPO_URL_PROP_KEY, VHOST_MAN_CLASS_NAME, VHOST_MAN_CLUST_CLASS_NAME, WS2S_CLASS_NAME, WS2S_CLUST_CLASS_NAME, XML_REPO_CLASS_PROP_VAL, XML_REPO_URL_PROP_VAL, XMPP_STANZA_ACK`

    - ### Fields inherited from interface tigase.disco.XMPPService

      `CMD_FEATURES, DEF_FEATURES, INFO_XMLNS, ITEMS_XMLNS`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ComponentProtocol()` Constructs ...

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `authenticated(ComponentIOService serv)`
    `void` | `authenticationFailed(ComponentIOService serv, Packet packet)`
    `void` | `bindHostname(String hostname, ComponentIOService serv)`
    `CompRepoItem` | `getCompRepoItem(String hostname)`
    `Map<String,Object>` | `getDefaults(Map<String,Object> params)` Returns default configuration settings for the component as a `Map` with keys as configuration property IDs and values as the configuration property values.
    `protected String` | `getDefTrafficThrottling()` Method description
    `String` | `getDiscoCategoryType()` Method description
    `String` | `getDiscoDescription()` Method description
    `protected long` | `getMaxInactiveTime()` Method description
    `protected Integer` | `getMaxQueueSize(int def)` Method description
    `ExtProcessor` | `getProcessor(String key)`
    `void` | `getStatistics(StatisticsList list)` Method returns component statistics.
    `List<tigase.xml.Element>` | `getStreamFeatures(ComponentIOService serv)`
    `StreamOpenHandler` | `getStreamOpenHandler(String xmlns)`
    `protected ComponentIOService` | `getXMPPIOService(Packet p)` Method description
    `protected ComponentIOService` | `getXMPPIOServiceInstance()` Method description
    `void` | `initBindings(Bindings binds)` Initialize a mapping of key/value pairs which can be used in scripts loaded by the server
    `protected boolean` | `isHighThroughput()` Method description
    `Queue<Packet>` | `processSocketData(ComponentIOService serv)` Method description
    `void` | `reconnectionFailed(Map<String,Object> port_props)` Method description
    `void` | `serviceStarted(ComponentIOService serv)` Method description
    `boolean` | `serviceStopped(ComponentIOService service)`
    `void` | `setProperties(Map<String,Object> properties)` Sets all configuration properties for the object.
    `void` | `tlsHandshakeCompleted(ComponentIOService service)`
    `void` | `unbindHostname(String hostname, ComponentIOService serv)`
    `boolean` | `writePacketToSocket(ComponentIOService ios, Packet p)` Method description
    `void` | `xmppStreamClosed(ComponentIOService serv)`
    `String` | `xmppStreamOpened(ComponentIOService serv, Map<String,String> attribs)`

    - ### Methods inherited from class tigase.server.ConnectionManager

      `addWaitingTask, checkHighThroughputProperty, checkTrafficLimits, countIOServices, doForAllServices, everyMinute, getDefPlainPorts, getDefSSLPorts, getParamsForPort, getServiceId, getServiceId, getUniqueId, getXMPPIOService, hashCodeForPacket, initializationCompleted, isTlsWantClientAuthEnabled, packetsReady, processingInThreads, processingOutThreads, processPacket, processUndeliveredPacket, release, setName, setupWatchdogThread, stop, updateConnectionDetails, writePacketsToSocket, writePacketToSocket, writePacketToSocket, writeRawData`

    - ### Methods inherited from class tigase.server.AbstractMessageReceiver

      `addOutPacket, addOutPacketNB, addOutPackets, addOutPacketWithTimeout, addPacket, addPacketNB, addPackets, addRegexRouting, addTimerTask, addTimerTask, addTimerTask, addTimerTask, addTimerTask, clearRegexRoutings, everyHour, everySecond, getRegexRoutings, isInRegexRoutings, newPacketId, processingThreads, processOutPacket, processPacket, removeRegexRouting, schedulerThreads, setMaxQueueSize, setParent, start`

    - ### Methods inherited from class tigase.server.BasicComponent

      `addComponentDomain, canCallCommand, checkCommandAcl, getComponentId, getComponentInfo, getDefHostName, getDefVHostItem, getDiscoCategory, getDiscoFeatures, getDiscoFeatures, getDiscoInfo, getDiscoInfo, getDiscoItems, getDiscoItems, getName, getScriptCommands, getScriptItems, getServiceEntity, getVHostItem, handlesLocalDomains, handlesNameSubdomains, handlesNonLocalDomains, isAdmin, isInitializationComplete, isLocalDomain, isLocalDomainOrComponent, isNonAdminCommands, isSubdomain, processScriptCommand, removeComponentDomain, removeServiceDiscoveryItem, setVHostManager, updateServiceDiscoveryItem, updateServiceDiscoveryItem, updateServiceDiscoveryItem, updateServiceEntity`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface tigase.server.ext.ComponentProtocolHandler

      `newPacketId`

    - ### Methods inherited from interface tigase.server.MessageReceiver

      `getDefHostName`

    - ### Methods inherited from interface tigase.server.ServerComponent

      `getComponentId, getComponentInfo, getName, isInitializationComplete`

- - ### Field Detail

    - #### AUTHENTICATION_TIMEOUT_PROP_KEY

          public static final String AUTHENTICATION_TIMEOUT_PROP_KEY

      Field description
      See Also:
        Constant Field Values

    - #### CLOSE_ON_SEQUENCE_ERROR_PROP_KEY

          public static final String CLOSE_ON_SEQUENCE_ERROR_PROP_KEY

      Field description
      See Also:
        Constant Field Values

    - #### EXTCOMP_BIND_HOSTNAMES

          public static final String EXTCOMP_BIND_HOSTNAMES

      Field description
      See Also:
        Constant Field Values

    - #### EXTCOMP_REPO_CLASS_PROP_KEY

          public static final String EXTCOMP_REPO_CLASS_PROP_KEY

      Field description
      See Also:
        Constant Field Values

    - #### EXTCOMP_REPO_CLASS_PROP_VAL

          public static final String EXTCOMP_REPO_CLASS_PROP_VAL

      Field description
      See Also:
        Constant Field Values

    - #### EXTCOMP_REPO_CLASS_PROPERTY

          public static final String EXTCOMP_REPO_CLASS_PROPERTY

      Field description
      See Also:
        Constant Field Values

    - #### IDENTITY_TYPE_KEY

          public static final String IDENTITY_TYPE_KEY

      Field description
      See Also:
        Constant Field Values

    - #### IDENTITY_TYPE_VAL

          public static final String IDENTITY_TYPE_VAL

      Field description
      See Also:
        Constant Field Values

    - #### MAX_AUTH_ATTEMPTS_PROP_KEY

          public static final String MAX_AUTH_ATTEMPTS_PROP_KEY

      Field description
      See Also:
        Constant Field Values

    - #### PACK_ROUTED_KEY

          public static final String PACK_ROUTED_KEY

      Field description
      See Also:
        Constant Field Values

    - #### RETURN_SERVICE_DISCO_KEY

          public static final String RETURN_SERVICE_DISCO_KEY

      Field description
      See Also:
        Constant Field Values

    - #### RETURN_SERVICE_DISCO_VAL

          public static final boolean RETURN_SERVICE_DISCO_VAL

      Field description
      See Also:
        Constant Field Values

    - #### PACK_ROUTED_VAL

          public boolean PACK_ROUTED_VAL

      Field description

  - ### Constructor Detail

    - #### ComponentProtocol

          public ComponentProtocol()

      Constructs ...

  - ### Method Detail

    - #### authenticated

          public void authenticated(ComponentIOService serv)

      Specified by:
        `authenticated` in interface `ComponentProtocolHandler`

    - #### authenticationFailed

          public void authenticationFailed(ComponentIOService serv,
                                  Packet packet)

      Specified by:
        `authenticationFailed` in interface `ComponentProtocolHandler`

    - #### getDefTrafficThrottling

          protected String getDefTrafficThrottling()

      Description copied from class: `ConnectionManager`
      Method description
      Overrides:
        `getDefTrafficThrottling` in class `ConnectionManager<ComponentIOService>`
      Returns:
        a value of `String`

    - #### bindHostname

          public void bindHostname(String hostname,
                          ComponentIOService serv)

      Specified by:
        `bindHostname` in interface `ComponentProtocolHandler`

    - #### getCompRepoItem

          public CompRepoItem getCompRepoItem(String hostname)

      Specified by:
        `getCompRepoItem` in interface `ComponentProtocolHandler`

    - #### getDefaults

          public Map<String,Object> getDefaults(Map<String,Object> params)

      Description copied from class: `AbstractMessageReceiver`
      Returns default configuration settings for the component as a `Map` with keys as configuration property IDs and values as the configuration property values. All the default parameters returned from this method are later passed to the `setProperties(...)` method. Some of them may have changed value if they have been overwritten in the server configuration. The configuration property value can be of any of the basic types: `int`, `long`, `boolean`, `String`.
      Specified by:
        `getDefaults` in interface `Configurable`
      Overrides:
        `getDefaults` in class `ConnectionManager<ComponentIOService>`
      Parameters:
        `params` - is a `Map` with some initial properties set for the starting up server. These parameters can be used as a hints to generate component's default configuration.
      Returns:
        a `Map` with the component default configuration.

    - #### getDiscoCategoryType

          public String getDiscoCategoryType()

      Description copied from class: `BasicComponent`
      Method description
      Overrides:
        `getDiscoCategoryType` in class `BasicComponent`
      Returns:
        a value of `String`

    - #### getDiscoDescription

          public String getDiscoDescription()

      Description copied from class: `BasicComponent`
      Method description
      Overrides:
        `getDiscoDescription` in class `BasicComponent`
      Returns:
        a value of `String`

    - #### getProcessor

          public ExtProcessor getProcessor(String key)

      Specified by:
        `getProcessor` in interface `ComponentProtocolHandler`

    - #### getStatistics

          public void getStatistics(StatisticsList list)

      Description copied from class: `AbstractMessageReceiver`
      Method returns component statistics. Please note, the method can be called every second by the server monitoring system therefore no extensive or lengthy calculations are allowed. If there are some statistics requiring lengthy operations like database access they must have `Level.FINEST` assigned and must be put inside the level guard to prevent generating them by the system monitor. The system monitor does not collect `FINEST` statistics.
      Level guard code looks like the example below:

           if (list.checkLevel(Level.FINEST)) {
             // Some CPU intensive calculations or lengthy operations
             list.add(getName(), "Statistic description", stat_value, Level.FINEST);
           }

      This way you make sure your extensive operation is not executed every second by the monitoring system and does not affect the server performance.
      Specified by:
        `getStatistics` in interface `StatisticsContainer`
      Overrides:
        `getStatistics` in class `ConnectionManager<ComponentIOService>`
      Parameters:
        `list` - is a `StatistcsList` where all statistics are stored.

    - #### getStreamFeatures

          public List<tigase.xml.Element> getStreamFeatures(ComponentIOService serv)

      Specified by:
        `getStreamFeatures` in interface `ComponentProtocolHandler`

    - #### getStreamOpenHandler

          public StreamOpenHandler getStreamOpenHandler(String xmlns)

      Specified by:
        `getStreamOpenHandler` in interface `ComponentProtocolHandler`

    - #### initBindings

          public void initBindings(Bindings binds)

      Description copied from class: `BasicComponent`
      Initialize a mapping of key/value pairs which can be used in scripts loaded by the server
      Overrides:
        `initBindings` in class `ConnectionManager<ComponentIOService>`
      Parameters:
        `binds` - A mapping of key/value pairs, all of whose keys are Strings.

    - #### processSocketData

          public Queue<Packet> processSocketData(ComponentIOService serv)

      Description copied from class: `ConnectionManager`
      Method description
      Specified by:
        `processSocketData` in class `ConnectionManager<ComponentIOService>`
      Returns:
        a value of `Queue<Packet>`

    - #### reconnectionFailed

          public void reconnectionFailed(Map<String,Object> port_props)

      Description copied from class: `ConnectionManager`
      Method description
      Specified by:
        `reconnectionFailed` in class `ConnectionManager<ComponentIOService>`

    - #### serviceStarted

          public void serviceStarted(ComponentIOService serv)

      Description copied from class: `ConnectionManager`
      Method description
      Overrides:
        `serviceStarted` in class `ConnectionManager<ComponentIOService>`

    - #### serviceStopped

          public boolean serviceStopped(ComponentIOService service)

      Specified by:
        `serviceStopped` in interface `IOServiceListener<ComponentIOService>`
      Overrides:
        `serviceStopped` in class `ConnectionManager<ComponentIOService>`

    - #### setProperties

          public void setProperties(Map<String,Object> properties)
                             throws ConfigurationException

      Description copied from interface: `Configurable`
      Sets all configuration properties for the object.
      Specified by:
        `setProperties` in interface `Configurable`
      Overrides:
        `setProperties` in class `ConnectionManager<ComponentIOService>`
      Parameters:
        `properties` - `Map` with the configuration
      Throws:
        `ConfigurationException` - - if setting configuration will fail which will make it unable to work

    - #### tlsHandshakeCompleted

          public void tlsHandshakeCompleted(ComponentIOService service)

      Specified by:
        `tlsHandshakeCompleted` in interface `IOServiceListener<ComponentIOService>`

    - #### unbindHostname

          public void unbindHostname(String hostname,
                            ComponentIOService serv)

      Specified by:
        `unbindHostname` in interface `ComponentProtocolHandler`

    - #### writePacketToSocket

          public boolean writePacketToSocket(ComponentIOService ios,
                                    Packet p)

      Description copied from class: `ConnectionManager`
      Method description
      Overrides:
        `writePacketToSocket` in class `ConnectionManager<ComponentIOService>`
      Returns:
        a value of `boolean`

    - #### xmppStreamClosed

          public void xmppStreamClosed(ComponentIOService serv)

      Specified by:
        `xmppStreamClosed` in interface `XMPPIOServiceListener<ComponentIOService>`

    - #### xmppStreamOpened

          public String xmppStreamOpened(ComponentIOService serv,
                                Map<String,String> attribs)

      Specified by:
        `xmppStreamOpened` in interface `XMPPIOServiceListener<ComponentIOService>`

    - #### getMaxInactiveTime

          protected long getMaxInactiveTime()

      Description copied from class: `ConnectionManager`
      Method description
      Specified by:
        `getMaxInactiveTime` in class `ConnectionManager<ComponentIOService>`
      Returns:
        a value of `long`

    - #### getMaxQueueSize

          protected Integer getMaxQueueSize(int def)

      Description copied from class: `AbstractMessageReceiver`
      Method description
      Overrides:
        `getMaxQueueSize` in class `AbstractMessageReceiver`
      Returns:
        a value of `Integer`

    - #### getXMPPIOService

          protected ComponentIOService getXMPPIOService(Packet p)

      Description copied from class: `ConnectionManager`
      Method description
      Overrides:
        `getXMPPIOService` in class `ConnectionManager<ComponentIOService>`
      Returns:
        a value of `IO`

    - #### getXMPPIOServiceInstance

          protected ComponentIOService getXMPPIOServiceInstance()

      Description copied from class: `ConnectionManager`
      Method description
      Specified by:
        `getXMPPIOServiceInstance` in class `ConnectionManager<ComponentIOService>`
      Returns:
        a value of `IO`

    - #### isHighThroughput

          protected boolean isHighThroughput()

      Description copied from class: `ConnectionManager`
      Method description
      Overrides:
        `isHighThroughput` in class `ConnectionManager<ComponentIOService>`
      Returns:
        a value of `boolean`

Copyright © 2015 "Tigase, Inc.". All rights reserved.